/* Constant values and macros */

#ifndef CONST_H_
#define CONST_H_

/* Can we get Assembly locations from running program? */

#define AT_FUNCTION(f,eip) (((f) = address_to_function((eip))) != -1)

/* We need to replace these with per-program values */
#define TOOLARGE ((unsigned)0x01000000)
#define LASTELF ((unsigned)0x09000000) /* Find last function+size addr */
#define STARTELF ((unsigned)0x080482bc)
#define TOPSTACK ((unsigned)0xbfffffff)

/* Assembly */
#define NOP	0x90
#define RET	0xc3
#define LEAVE	0xc9
#define	CALL	0xe8
#define INT3	0xcc
#define INS_IS_ASM(ins,as)	if((0x00FF & (ins))==as)

#define BREAK_LENGTH	1
const char breakpoint[] = {INT3,0};

/* Ptrace Macros */
#define WAIT_EXEC	1407
#define STOP_EXEC   4991
#define TRACE(x)	ptrace(PTRACE_TRACEME, (x), NULL, NULL)
#define STEP(x)		ptrace(PTRACE_SINGLESTEP, (x), NULL, NULL)
#define GET_REGS(x,y)	ptrace(PTRACE_GETREGS, (x), NULL, (y))
#define PEEK(x,y)	ptrace(PTRACE_PEEKTEXT, (x), (y), NULL)
#define POKE(x,y,z)	ptrace(PTRACE_POKEDATA, (x), (y), (z))
#define ATTACH(x)	ptrace(PTRACE_ATTACH, (x), NULL, NULL)
#define DETACH(x)	ptrace(PTRACE_DETACH, (x), NULL, NULL)
#define PKILL(x)    ptrace(PTRACE_KILL, (x), NULL, NULL)
#define PCONT(x,y)  ptrace(PTRACE_CONT, (x), (y), NULL)

#define SSTEP(X)	if (STEP(X) != 0) {perror("ptrace");exit(errno);}
#define STEPW(X,Y)	SSTEP(X) waitpid(X, Y, WUNTRACED)

/* These files are used to translate a running pid to it's running file */
/* PIDPRELUDE PID PIDLOCATION = symbolic link of command */
#define PIDPRELUDE "/proc/"
#define PIDLOCATION "/exe"
#define MAXPATHNAME 255
#define MAIN_STRING "main"
#define BINARY "./a.out"
#define DEVNULL "/dev/null"

#define MAXARGS 6 /* hopefully we can detect and stop before this */

#endif /* CONST_H_ */
