/* here are our global values, which we need to phase out when possible */

#ifndef GLOBALS_H_
#define GLOBALS_H_

/* Anything else here */
static long ins = NOP;
static struct user_regs_struct save_regs;
static struct user_regs_struct start_regs; /* Regs we first grab from a program */

static unsigned long first_func_addr = 0xFFFFFFFF; /* objdump -x */
static unsigned long last_func_addr = 0x00000000; /* Last valid function address */
static unsigned long heap_start = 0x00000000; /* .bss section */
static unsigned long stack_start = 0xbfffffff; /* we could get from ebp */

/* Read all the information from a program header to interpret the program */
/*
struct
{
    static long first_func_addr = 0xFFFFFFFF; // objdump -x
    static long last_func_addr = 0x00000000; // Last valid function address
    static long heap_start = 0x00000000; // .bss section
    static long stack_start = 0xbfffffff; // we could get from ebp
} program_specifics;
*/

/* a function that we don't know about */
//static char* unknown_function = "*unknown*";

/* Global Functions */
static Elf_func* functions = NULL;
static int num_func = 0;

char *name_table = NULL;	/* global sections name table */
char *sym_name_table = NULL;	/* global name table for the symbol table */

char *elf_image = NULL;         /* used with mmap() */
int elf_fp = 0; 		/* fd for the file */
struct stat elf_stat;		/* used with stat() */

unsigned char byte_order;

/* static variables */
static char* main_string = MAIN_STRING;
static char* run_command = BINARY;
static cmd_line* cl = NULL;	/* cmd_line arguments for this program */
char **command = NULL;		/* command+args to run */

static int MAXSTRING=16; /* print dots after that */
static int MAXARRAY=16; /* checking for array values */

static func_args* prev_args = NULL;

#endif /* GLOBALS_H_ */

