/* Contains the structures we will use in our program */

#ifndef STRUCT_H_
#define STRUCT_H_

/* Referenced from #include <asm/user.h>
 * This is the old layout of "struct pt_regs", and
 * is still the layout used by user mode (the new
 * pt_regs doesn't have all registers as the kernel
 * doesn't use the extra segment registers)
 */
struct user_regs_struct {
	long ebx, ecx, edx, esi, edi, ebp, eax;
	unsigned short ds, __ds, es, __es;
	unsigned short fs, __fs, gs, __gs;
	long orig_eax, eip;
	unsigned short cs, __cs;
	long eflags, esp;
	unsigned short ss, __ss;
};

typedef struct
{
	char* func_name;
	unsigned long addr;
	unsigned long size;
	int info;
	//char saved_ins[BREAK_LENGTH];
	struct user_regs_struct regs;
} Elf_func;

typedef struct
{
	int func_verbosity;	/* controls functions that start with _ */
	int begin_start;	/* 1=Start printing at below function */
	char* start_function;	/* function to start recording at */
	int end_ret;		/* 1=Stop when we hit a ret at below function */
	char* ret_function;	/* Stop recording when we hit a ret here */
	int function_info;	/* Display list of functions to search on */
	int normal_call;	/* Display info on calls */
	int normal_ret;		/* Display info on returns */
	int extra_ret;		/* Display extra pointless info on a ret */
	int stack;		/* List number of functions saved on stack */
	int show_eip;		/* Report eip when we break anywhere */
	FILE *out_stream; 	/* stout redirected to a pipe */
	char *command;		/* command to run */
	pid_t child_pid;	/* PID to attach to */
} cmd_line;

/*
typedef struct
{
	char* func_name;
	unsigned long addr;
	unsigned long size;
	
    int num_arguments;
    unsigned long arguments[num_arguments];
    char argument_values[num_arguments];
    unsigned long return_value;
    char return_type;

} function;
*/


typedef struct
{
    int used;
    unsigned long arguments[MAXARGS]; /* value, not address */
    int function_num;
} func_args;

#endif /* STRUCT_H_ */
